﻿//----------------------------------------------------------------------------------------
//
//	Copyright (C) 2008-2015 Ryo Suzuki
//
//	Licensed under the MIT License.
//
//	Permission is hereby granted, free of charge, to any person obtaining a copy
//	of this software and associated documentation files(the "Software"), to deal
//	in the Software without restriction, including without limitation the rights
//	to use, copy, modify, merge, publish, distribute, sublicense, and / or sell
//	copies of the Software, and to permit persons to whom the Software is
//	furnished to do so, subject to the following conditions :
//	
//	The above copyright notice and this permission notice shall be included in
//	all copies or substantial portions of the Software.
//	
//	THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
//	IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
//	FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.IN NO EVENT SHALL THE
//	AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
//	LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
//	OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
//	THE SOFTWARE.
//
//----------------------------------------------------------------------------------------

# pragma once
# pragma comment (linker, "/entry:\"wWinMainCRTStartup\"")

# if(_MSC_FULL_VER < 180030723)
#  error Visual Studio 2013 update 3 以降が必要です | Visual Studio 2013 with update 3 or later is required
# endif

# ifndef SIV3D_INCLUDED
#	define SIV3D_INCLUDED
# endif

# ifdef _DEBUG
#	pragma comment (lib, "Siv3D_d")
# else
#	pragma comment (lib, "Siv3D")
# endif

# pragma comment (lib, "winmm")
# pragma comment (lib, "IPHLPAPI")
# pragma comment (lib, "gdiplus")
# pragma comment (lib, "Shlwapi")
# pragma comment (lib, "Setupapi")
# pragma comment (lib, "Wininet")
# pragma comment (lib, "Winhttp")
# pragma comment (lib, "imm32")
# pragma comment (lib, "Strmiids")
# pragma comment (lib, "Vfw32")
# ifdef _DEBUG
#	pragma comment (lib, "libpng/libpng16_d")
#	pragma comment (lib, "zlib/zlib_d")
#	pragma comment (lib, "libjpeg-turbo/turbojpeg-static_d")
#	pragma comment (lib, "OpenJPEG/openjpeg_d")
#	pragma comment (lib, "libwebp/libwebp_debug")
#	pragma comment (lib, "OpenCV/opencv_core249d")
#	pragma comment (lib, "OpenCV/opencv_imgproc249d")
#	pragma comment (lib, "OpenCV/opencv_objdetect249d")
#	pragma comment (lib, "OpenCV/opencv_highgui249d")
#	pragma comment (lib, "OpenCV/opencv_calib3d249d")
#	pragma comment (lib, "libogg/libogg_static_d")
#	pragma comment (lib, "libvorbis/libvorbis_static_d")
#	pragma comment (lib, "libvorbis/libvorbisfile_static_d")
# else
#	pragma comment (lib, "libpng/libpng16.lib")
#	pragma comment (lib, "zlib/zlib.lib")
#	pragma comment (lib, "libjpeg-turbo/turbojpeg-static")
#	pragma comment (lib, "OpenJPEG/openjpeg.lib")
#	pragma comment (lib, "libwebp/libwebp.lib")
#	pragma comment (lib, "OpenCV/opencv_core249")
#	pragma comment (lib, "OpenCV/opencv_imgproc249")
#	pragma comment (lib, "OpenCV/opencv_objdetect249")
#	pragma comment (lib, "OpenCV/opencv_highgui249")
#	pragma comment (lib, "OpenCV/opencv_calib3d249")
#	pragma comment (lib, "libogg/libogg_static")
#	pragma comment (lib, "libvorbis/libvorbis_static")
#	pragma comment (lib, "libvorbis/libvorbisfile_static")
# endif

//
// ユーティリティ
//
	// ライブラリのバージョン
	# include "Siv3DVersion.hpp"
	// 前方宣言
	# include "Siv3DFwd.hpp"
	// 型
	# include "SivTypes.hpp"
	// ユーティリティ
	# include "SivUtility.hpp"
	// コピー禁止クラス
	# include "SivUncopyable.hpp"
	// static assert
	# include "SivStaticAssertMacro.hpp"
	// 無効値表現型
	# include "SivOptional.hpp"
	// unspecified
	# include "SivUnspecified.hpp"
	// アライメントを考慮したアロケータ
	# include "SivAlignedAllocator.hpp"
	// 動的配列
	# include "SivArray.hpp"
	// 動的二次元配列
	# include "SivGrid.hpp"
//
// 文字と文字列
//
	// 文字
	# include "SivChar.hpp"
	// 文字列
	# include "SivString.hpp"
	// 文字列ビュー
	# include "SivStringView.hpp"
	// 文字コード変換
	# include "SivCharacterSet.hpp"
	// 数値
	# include "SivNumber.hpp"
	// データ -> 文字列 の変換
	# include "SivFormat.hpp"
	// 文字列 -> データ の変換
	# include "SivParse.hpp"
	// 正規表現
	# include "SivRegex.hpp"
//
// 時刻と時間
//
	// 時間の単位
	# include "SivDuration.hpp"
	// 日付
	# include "SivDate.hpp"
	// 日付と時刻
	# include "SivDateTime.hpp"
	// 時間
	# include "SivTime.hpp"
	// 経過時間の測定
	# include "SivTimer.hpp"
	// イベント付き経過時間の測定
	# include "SivEventTimer.hpp"
	// 処理にかかった時間の測定
	# include "SivProfilerUtility.hpp"
//
// ファイル I/O と暗号化
//
	// ファイルとディレクトリ
	# include "SivFileSystem.hpp"
	// IReader インタフェース
	# include "SivIReader.hpp"
	// 読み込み用バッファ
	# include "SivMemoryReader.hpp"
	// バイナリファイルの読み込み
	# include "SivBinaryReader.hpp"
	// IWriter インタフェース
	# include "SivIWriter.hpp"
	// 書き込み用バッファ
	# include "SivMemoryWriter.hpp"
	// バイナリファイルの書き込み
	# include "SivBinaryWriter.hpp"
	// テキストファイルの読み込み
	# include "SivTextReader.hpp"
	// テキストファイルの書き込み
	# include "SivTextWriter.hpp"
	// Base64
	# include "SivBase64.hpp"
	// MD5
	# include "SivMD5.hpp"
	// ログファイル
	# include "SivLogger.hpp"
	// 暗号化
	# include "SivCrypto.hpp"
	// ファイルとフォルダの圧縮・展開
	# include "SivCompression.hpp"
	// アーカイブされたファイルからの読み込み
	# include "SivArchivedFileReader.hpp"
	// ファイルアーカイブ
	# include "SivFileArchive.hpp"
	// CSV ファイルの読み込み
	# include "SivCSVReader.hpp"
	// CSV ファイルの書き出し
	# include "SivCSVWriter.hpp"
	// INI ファイルの読み込み
	# include "SivINIReader.hpp"
	// INI ファイルの書き出し
	# include "SivINIWriter.hpp"
	// XML ファイルの読み込み
	# include "SivXMLReader.hpp"
	// JSON のデータ
	# include "SivJSONValue.hpp"
	// JSON ファイルの読み込み
	# include "SivJSONReader.hpp"
	// Zip 圧縮ファイルの読み込み
	# include "SivZipReader.hpp"
//
// 色と二次元図形
//
	// 定数
	# include "SivMathConstants.hpp"
	// RGB カラー
	# include "SivColor.hpp"
	// HSV カラー
	# include "SivHSV.hpp"
	// ベクトル
	# include "SivPointVector.hpp"
	// 円座標
	# include "SivCircular.hpp"
	// 円柱座標
	# include "SivCylindrical.hpp"
	// 球面座標
	# include "SivSpherical.hpp"
	// 3x2 行列
	# include "SivMat3x2.hpp"
	// 線分
	# include "SivLine.hpp"
	// 長方形
	# include "SivRectangle.hpp"
	// 円
	# include "SivCircle.hpp"
	// 楕円
	# include "SivEllipse.hpp"
	// 三角形
	# include "SivTriangle.hpp"
	// 四角形
	# include "SivQuad.hpp"
	// 角丸長方形
	# include "SivRoundRect.hpp"
	// 連続した複数の線分
	# include "SivLineString.hpp"
	// 多角形
	# include "SivPolygon.hpp"
	// 多角形の集合
	# include "SivMultiPolygon.hpp"
	// 乱数生成エンジン
	# include "SivRNG.hpp"
	// 乱数の分布
	# include "SivDistribution.hpp"
	// 乱数ユーティリティ
	# include "SivRandom.hpp"
	// 数学関数
	# include "SivMath.hpp"
	// Easing 関数
	# include "SivEasing.hpp"
	// Easing ユーティリティ
	# include "SivEasingController.hpp"
	// 二次元幾何
	# include "SivGeometry2D.hpp"
	// 矢印形
	# include "SivArrow.hpp"
	// Perlin Noise
	# include "SivPerlinNoise.hpp"
	// スプライン
	# include "SivSpline.hpp"
	// SIMD
	# include "SivSIMD.hpp"
	// 半精度浮動小数点数
	# include "SivHalfFloat.hpp"
//
// 画像処理
//
	// メモリ上の画像
	# include "SivImage.hpp"
	// 画像のフォーマット
	# include "SivTextureFormat.hpp"
	// カスタムカラーフォーマット
	# include "SivCustomColor.hpp"
	// カスタムカラーフォーマットの画像
	# include "SivCustomImage.hpp"
	// QR コードの作成と認識
	# include "SivQR.hpp"
//
// 音声処理
//
	// 音声波形のサンプル
	# include "SivWaveSample.hpp"
	// 音声波形
	# include "SivWave.hpp"
	// FFT
	# include "SivFFT.hpp"
//
// 動画ファイル
//
	// 動画ファイルの書き込み
	# include "SivVideoWriter.hpp"
	// 動画ファイルの読み込み
	# include "SivVideoReader.hpp"
//
// ネットワーク・通信
//
	// シリアル通信
	# include "SivSerial.hpp"
	// (未実装)
	//# include "SivOSC.hpp"
	// インターネット接続
	# include "SivInternet.hpp"
	// Twitter
	# include "SivTwitter.hpp"
	// (未実装)
	//# include "SivTCP.hpp"
	// (未実装)
	//# include "SivUDP.hpp"
//
// システム全般
//
	// コマンドライン
	# include "SivCommandLine.hpp"
	// ユーザ固有 ID の取得
	# include "SivUID.hpp"
	// MIDI
	# include "SivMidi.hpp"
	// システム
	# include "SivSystem.hpp"
	// ウィンドウ
	# include "SivWindow.hpp"
	// メッセージボックス
	# include "SivMessageBox.hpp"
	// クリップボード
	# include "SivClipboard.hpp"
	// ドラッグ & ドロップ
	# include "SivDragdrop.hpp"
	// ダイアログ
	# include "SivDialog.hpp"
	// プロファイリング
	# include "SivProfiler.hpp"
//
// 入力デバイス
//
	// マイク入力
	# include "SivRecorder.hpp"
	// キー入力
	# include "SivKey.hpp"
	// マウス
	# include "SivMouse.hpp"
	// タッチ
	# include "SivTouch.hpp"
	// ペンタブレット
	# include "SivPentablet.hpp"
	// ゲームパッド
	# include "SivGamepad.hpp"
	// XInput 対応ゲームコントローラー
	# include "SivXInput.hpp"
	// 入力全般
	# include "SivInput.hpp"
	// Kinect V1
	# include "SivKinectV1.hpp"
	// Kinect V2
	# include "SivKinectV2.hpp"
	// Tobii Eye X
	# include "SivTobiiEyeX.hpp"
//
// サウンドとムービー
//
	// サウンド
	# include "SivSound.hpp"
	// タイムストレッチ・ピッチシフト可能なサウンド
	# include "SivDynamicSound.hpp"
	// サウンドのビートカウント
	# include "SivSoundBeat.hpp"
	// ムービー
	# include "SivMediaPlayer.hpp"
//
// グラフィックス
//
	// ブレンドステート
	# include "SivBlendState.hpp"
	// ラスタライザーステート
	# include "SivRasterizerState.hpp"
	// デプスステートとステンシルステート
	# include "SivDepthStencilState.hpp"
	// サンプラーステート
	# include "SivSamplerState.hpp"
	// レンダーステート
	# include "SivRenderState.hpp"
	// シェーダ
	# include "SivShader.hpp"
	// 頂点シェーダ
	# include "SivVertexShader.hpp"
	// ピクセルシェーダ
	# include "SivPixelShader.hpp"
	// 定数バッファ
	# include "SivConstantBuffer.hpp"
	// 頂点レイアウト
	# include "SivInputLayout.hpp"
	// グラフィックス全般
	# include "SivGraphics.hpp"
	// スクリーンショット
	# include "SivScreenCapture.hpp"
	// 2D グラフィックス設定
	# include "SivGraphics2D.hpp"
//
// テクスチャ
//
	// テクスチャ
	# include "SivTexture.hpp"
	// 領域を指定したテクスチャ
	# include "SivTextureRegion.hpp"
	// 四角形に貼り付けたテクスチャ
	# include "SivTexturedQuad.hpp"
	// 動的テクスチャ
	# include "SivDynamicTexture.hpp"
//
// 2D スプライト
//
	// 2D スプライト
	# include "SivSprite.hpp"

//
// フォント
//
	// キネティックタイポグラフィ
	# include "SivKineticTypography.hpp"
	// フォント
	# include "SivFont.hpp"
//
// 標準 GUI
//
	// ウィジェットのスタイル
	# include "SivWidgetStyle.hpp"
	// ウィジェットの基本クラス
	# include "SivIWidget.hpp"
	// テキストウィジェット
	# include "SivGUIText.hpp"
	// 改行ウィジェット
	# include "SivGUINewLine.hpp"
	// テクスチャウィジェット
	# include "SivGUITexture.hpp"
	// 水平線ウィジェット
	# include "SivGUIHorizontalLine.hpp"
	// ボタンウィジェット
	# include "SivGUIButton.hpp"
	// トグルスイッチウィジェット
	# include "SivGUIToggleSwitch.hpp"
	// 水平スライダーウィジェット
	# include "SivGUISlider.hpp"
	// チェックボックスウィジェット
	# include "SivGUICheckBox.hpp"
	// ラジオボタンウィジェット
	# include "SivGUIRadioButton.hpp"
	// テキスト入力フィールドウィジェット
	# include "SivGUITextField.hpp"
	// テキスト入力エリアウィジェット
	# include "SivGUITextArea.hpp"
	// GUI
	# include "SivGUI.hpp"
	// カーソル
	# include "SivCursor.hpp"
//
// Web カメラと AR
//
	// Web カメラ
	# include "SivWebcam.hpp"
	// AR マーカー
	# include "SivAR.hpp"
//
// 3D 幾何
//
	// クォータニオン
	# include "SivQuaternion.hpp"
	// 4x4 行列
	# include "SivMat4x4.hpp"
	// レイ
	# include "SivRay.hpp"
	// 3D 線分
	# include "SivLine3D.hpp"
	// 3D 三角形
	# include "SivTriangle3D.hpp"
	// メッシュデータ
	# include "SivMeshData.hpp"
	// メッシュ
	# include "SivMesh.hpp"
	// 動的メッシュ
	# include "SivDynamicMesh.hpp"
	// 変換情報を持ったメッシュ
	# include "SivTransformedMesh.hpp"
	// パーティクル
	# include "SivParticle.hpp"
	// 平面
	# include "SivPlane.hpp"
	// 球
	# include "SivSphere.hpp"
	// ボックス
	# include "SivBox.hpp"
	// 円盤
	# include "SivDisc.hpp"
	// 円柱
	# include "SivCylinder.hpp"
	// 円錐
	# include "SivCone.hpp"
	// 3D 幾何
	# include "SivGeometry3D.hpp"
	// OBJ ファイル読み込み
	# include "SivModelLoader.hpp"
	// 3D モデル
	# include "SivModel.hpp"
	// 3D カメラ
	# include "SivCamera.hpp"
	// フォグ
	# include "SivFog.hpp"
	// ライト
	# include "SivLight.hpp"
	// 3D グラフィックス設定
	# include "SivGraphics3D.hpp"
	// ポストエフェクト
	# include "SivPostEffect.hpp"
//
// アセット
//
	// アセット管理
	# include "SivAsset.hpp"
	// Sound アセット
	# include "SivSoundAsset.hpp"
	// Texture アセット
	# include "SivTextureAsset.hpp"
	// Font アセット
	# include "SivFontAsset.hpp"
	// GUI アセット
	# include "SivGUIAsset.hpp"
	// (未実装)
	//# include "SivModelAsset.hpp"
//
// ユーティリティ
//
	// エフェクト
	# include "SivEffect.hpp"
	// コンソールウィンドウ
	# include "SivConsole.hpp"
	// デバッグ出力
	# include "SivApplicationUtility.hpp"
	// アドオン
	# include "SivAddon.hpp"
	// ループユーティリティ
	# include "SivStep.hpp"

# ifndef NO_S3D_USING
	using namespace s3d;
# endif

#ifndef NO_MATH_USING
	using namespace s3d::Math;
#endif
