﻿//-----------------------------------------------
//
//	This file is part of the Siv3D Engine.
//
//	Copyright (C) 2008-2015 Ryo Suzuki
//
//	Licensed under the MIT License.
//
//-----------------------------------------------

# pragma once
# include "Siv3DFwd.hpp"
# include "SivArray.hpp"
# include "SivMesh.hpp"

namespace s3d
{
	/**
	*	@brief 動的テクスチャ
	*
	*	描画可能なイメージです。
	*	Texture と異なり、メモリを再確保することなくイメージデータを更新できます。
	*/
	class DynamicMesh : public Mesh
	{
	public:

		/**
		*
		*/
		DynamicMesh(
			);

		DynamicMesh(
			const MeshData& meshData
			);

		bool
			fill(
			const MeshData& meshData
			);

		bool
			fillVertices(
			const Array<MeshVertex>& vertices
			);

		bool
			fillIndices(
			const Array<unsigned>& indices
			);

		bool
			tryFillVertices(
			const Array<MeshVertex>& vertices
			);

		bool
			tryFillIndices(
			const Array<unsigned>& indices
			);
	};
}
