﻿//-----------------------------------------------
//
//	This file is part of the Siv3D Engine.
//
//	Copyright (C) 2008-2015 Ryo Suzuki
//
//	Licensed under the MIT License.
//
//-----------------------------------------------

# pragma once
# include "SivPointVector.hpp"
# include "SivQuad.hpp"

namespace s3d
{
	struct FloatRect
	{
		float left, top, right, bottom;

		FloatRect() = default;

		FloatRect(float l, float t, float r, float b)
			: left(l)
			, top(t)
			, right(r)
			, bottom(b) {}

		FloatRect(int32 l, int32 t, int32 r, int32 b)
			: left(static_cast<float>(l))
			, top(static_cast<float>(t))
			, right(static_cast<float>(r))
			, bottom(static_cast<float>(b)) {}

		FloatRect(double l, double t, double r, double b)
			: left(static_cast<float>(l))
			, top(static_cast<float>(t))
			, right(static_cast<float>(r))
			, bottom(static_cast<float>(b)) {}
	};

	struct FloatQuad
	{
		Float2 tl, tr, br, bl;

		FloatQuad() = default;

		FloatQuad(const Vec2& _tl, const Vec2& _tr, const Vec2& _br, const Vec2& _bl)
			: tl(_tl)
			, tr(_tr)
			, br(_br)
			, bl(_bl) {}

		FloatQuad(const Quad& q)
			: tl(q.tl)
			, tr(q.tr)
			, br(q.br)
			, bl(q.bl) {}
	};
}
