﻿//-----------------------------------------------
//
//	This file is part of the Siv3D Engine.
//
//	Copyright (C) 2008-2015 Ryo Suzuki
//
//	Licensed under the MIT License.
//
//-----------------------------------------------

# pragma once
# include "SivTypes.hpp"
# include <DirectXPackedVector.h>

namespace s3d
{ 
	/// <summary>
	/// 半精度浮動小数点数
	/// </summary>
	struct HalfFloat
	{
		uint16 m_value;

		HalfFloat() = default;

		HalfFloat(float value)
		{
			set(value);
		}

		template<typename Type> HalfFloat(Type value)
			: HalfFloat(static_cast<float>(value)) {}

		float get() const
		{
			return DirectX::PackedVector::XMConvertHalfToFloat(m_value);
		}

		void set(float value)
		{
			m_value = DirectX::PackedVector::XMConvertFloatToHalf(value);
		}

		template<typename Type>
		void set(Type value)
		{
			set(static_cast<float>(value));
		}

		operator float() const
		{
			return get();
		}
	};
}
