﻿//-----------------------------------------------
//
//	This file is part of the Siv3D Engine.
//
//	Copyright (C) 2008-2015 Ryo Suzuki
//
//	Licensed under the MIT License.
//
//-----------------------------------------------

# pragma once
# include "Siv3DFwd.hpp"
# include "SivWidgetStyle.hpp"
# include "SivString.hpp"

namespace s3d
{
	class IWidget
	{
	public:

		WidgetStyle m_style;

		IWidget() {}

		IWidget(const WidgetStyle& style)
			: m_style(style) {}

		virtual ~IWidget(){}

		virtual const String& getWidgetName() const = 0;

		virtual Point getSize() const = 0;

		virtual bool forceNewLineBefore() const = 0;

		virtual bool forceNewLineAfter() const = 0;

		virtual void update(const WidgetState& state) = 0;

		virtual void draw(const WidgetState& state) const = 0;
	};
}
