﻿//-----------------------------------------------
//
//	This file is part of the Siv3D Engine.
//
//	Copyright (C) 2008-2015 Ryo Suzuki
//
//	Licensed under the MIT License.
//
//-----------------------------------------------

# pragma once
# include <functional>
# include "SivPointVector.hpp"

namespace s3d
{
	struct KineticTypography
	{
		KineticTypography() = default;

		KineticTypography(Vec2 _pos, Vec2 _origin, unsigned _textLength, unsigned _index, Color _col, wchar _ch)
			: pos(_pos)
			, origin(_origin)
			, textLength(_textLength)
			, index(_index)
			, col(_col)
			, ch(_ch) {}

		Vec2 pos;

		Vec2 origin;

		uint32 textLength;

		uint32 index;

		Color col;

		wchar ch;
	};

	using KineticTypographyFunction_t = std::function<void(KineticTypography&)>;
}
