﻿//-----------------------------------------------
//
//	This file is part of the Siv3D Engine.
//
//	Copyright (C) 2008-2015 Ryo Suzuki
//
//	Licensed under the MIT License.
//
//-----------------------------------------------

# pragma once

namespace s3d
{
	namespace Math
	{
		/// <summary>
		/// π
		/// </summary>
		extern const __declspec(selectany) double Pi = 3.14159265358979323846;

		/// <summary>
		/// π (float)
		/// </summary>
		extern const __declspec(selectany) float PiF = 3.14159265358979323846f;

		/// <summary>
		/// 2π
		/// </summary>
		extern const __declspec(selectany) double TwoPi = Pi * 2.0;

		/// <summary>
		/// 2π (float)
		/// </summary>
		extern const __declspec(selectany) float TwoPiF = PiF * 2.0f;

		/// <summary>
		/// (1/2)π
		/// </summary>
		extern const __declspec(selectany) double HalfPi = Pi / 2.0;

		/// <summary>
		/// (1/2)π (float)
		/// </summary>
		extern const __declspec(selectany) float HalfPiF = PiF / 2.0f;

		/// <summary>
		/// (1/3)π
		/// </summary>
		extern const __declspec(selectany) double OneThirdPi = Pi / 3.0;

		/// <summary>
		/// (1/3)π (float)
		/// </summary>
		extern const __declspec(selectany) float OneThirdPiF = PiF / 3.0f;

		/// <summary>
		/// (1/4)π
		/// </summary>
		extern const __declspec(selectany) double QuarterPi = Pi / 4.0;

		/// <summary>
		/// (1/4)π (float)
		/// </summary>
		extern const __declspec(selectany) float QuarterPiF = PiF / 4.0f;
	}
}
